#ifndef AGI_NMLK_H
#define AGI_NMLK_H 1


/*
*	Header file for agi-namelookup.c
*/


/*  Name and number  */
/*  2023-08-31 Optional wide name  */
#ifdef ANL_WITH_WIDE_NAMES
 #define ANL_NAME_SIZ 72
#else
 #define ANL_NAME_SIZ 32
#endif
#define ANL_NUM_SIZ  20
enum { ANL_NAME_MAX = ANL_NAME_SIZ - 1 };
enum { ANL_NUM_MAX  = ANL_NUM_SIZ  - 1 };

struct phnum {
	char num[ANL_NUM_SIZ];
	int  len;
	char name[ANL_NAME_SIZ];
};

struct phidx {
	char num[ANL_NUM_SIZ];
	int  len;		/*  Phone numer length  */
	int  offs;		/*  Phone numer file offset  */
	int  namlen;		/*  Name length  */
};

/*
*    Files and paths
*/

/*  Config files  */
#define ANL_CONF_PATH "/etc/namelookup-agi/"
#define ANL_CONF_FIL  "agi-namelookup.conf"
#define ANL_BLCK_FIL  "agi-nameblock.db"
/*  With paths  */
#define ANL_CONFIG_FILE  ANL_CONF_PATH ANL_CONF_FIL
#define ANL_BLOCK_FILE   ANL_CONF_PATH ANL_BLCK_FIL

/*  Databases  */
#define ANL_NUMS_PATH "/var/local/lib/phonebook/"
#define ANL_NUMS_FIL  "numbers.db"
#define ANL_NUMS_IDX  "numbers.idx"
#define ANL_NUMS_LST  "numbers.lst"
#define ANL_AREA_FIL  "areas.db"
#define ANL_AREA_IDX  "areas.idx"
#define ANL_AREA_LST  "areas.lst"
#define ANL_REGS_FIL  "regions.db"
#define ANL_REGS_IDX  "regions.idx"
#define ANL_REGS_LST  "regions.lst"
/*  With paths  */
#define ANL_NUMBERS_FILE  ANL_NUMS_PATH ANL_NUMS_FIL
#define ANL_NUMBERS_INDEX ANL_NUMS_PATH ANL_NUMS_IDX
#define ANL_NUMBERS_LIST  ANL_NUMS_PATH ANL_NUMS_LST
#define ANL_AREAS_FILE    ANL_NUMS_PATH ANL_AREA_FIL
#define ANL_AREAS_INDEX   ANL_NUMS_PATH ANL_AREA_IDX
#define ANL_AREAS_LIST    ANL_NUMS_PATH ANL_AREA_LST
#define ANL_REGIONS_FILE  ANL_NUMS_PATH ANL_REGS_FIL
#define ANL_REGIONS_INDEX ANL_NUMS_PATH ANL_REGS_IDX
#define ANL_REGIONS_LIST  ANL_NUMS_PATH ANL_REGS_LST

#endif	/*  agi-namelookup.h  */

