#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "agi-namelookup.h"


/*
*    Converts regular to compact format
*
*    Author: R.J. van der Putten, Leiden, Holland, 
*    rob at sput dot nl.
* 
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License version 3 as
*    published by the Free Software Foundation.
* 
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*/


int main(int argc, char **argv)
{
    int ptr;
    char numnam[256], idxnam[256], lstnam[256];
    struct phnum num;
    struct phidx idx;
    FILE *numfil, *idxfil, *lstfil;

    ptr = 0;
    memset(numnam, 0, 256);
    memset(idxnam, 0, 256);
    memset(lstnam, 0, 256);
    numfil = NULL;
    idxfil = NULL;
    lstfil = NULL;
    memset(&num, 0, sizeof(num));
    memset(&idx, 0, sizeof(idx));

    if (argc != 2) {
	fprintf(stderr, "Specify file prefix\n");
	exit(1);
    }

    snprintf(numnam, 255, "%s.db", argv[1]);
    snprintf(idxnam, 255, "%s.idx", argv[1]);
    snprintf(lstnam, 255, "%s.lst", argv[1]);

    if ((numfil = fopen(numnam, "r")) == NULL) {
	fprintf(stderr, "Can't open %s\n", numnam);
	exit(1);
    }
    if ((idxfil = fopen(idxnam, "w")) == NULL) {
	fprintf(stderr, "Can't open %s\n", idxnam);
	fclose(numfil);
	exit(1);
    }

    if ((lstfil = fopen(lstnam, "w")) == NULL) {
	fprintf(stderr, "Can't open %s\n", lstnam);
	fclose(idxfil);
	fclose(numfil);
	exit(1);
    }

    while (fread(&num, sizeof(num), 1, numfil)) {
	memset(&idx, 0, sizeof(idx));
	memcpy(idx.num, num.num, ANL_NUM_SIZ);
	idx.len = num.len;
	idx.offs = ptr;
	idx.namlen = strlen(num.name);
	//printf("%s %d %d %d %s\n", idx.num, idx.len, idx.offs, idx.namlen, num.name);
	fwrite(&idx, sizeof(idx), 1, idxfil);
	fwrite(&(num.name), 1, idx.namlen + 1, lstfil);
	ptr = ptr + idx.namlen + 1;
    }

    fclose(lstfil);
    fclose(idxfil);
    fclose(numfil);

    return(0);
}

